#include <iostream>
using namespace std;
long long kg[1000000];
int main () {
    long long n,a,kgs=0;
    cin>>n;
    long long b[n],t[n];
    cin>>a>>b[0];
    t[0]=1;
    kg[0]=b[0];
    kgs=kg[0];
    for(int i=1;i<n;i++){
        cin>>a>>b[i];
        if(b[i]>0) {
            t[i]=t[a-1]+1;
            kg[i]=kg[a-1]+b[i];
            kgs+=kg[i];
        }
        else {
            t[i]=t[a-1]-1;
            kg[i]=kg[a-1]-b[a-1];
            kgs+=kg[i];
        }
    }
    cout<<kgs<<endl;
    return 0;
}
